<?php
//TITLE=QuickBasic compiler clone

$title = 'QuickBasic compiler clone';
$progname = 'qbc';

function usagetext($prog)
{
  exec($prog.' --help', $kk);
  $k='';foreach($kk as $s)$k.="$s\n";
  return $k;
}

$text = array(
   '1. Purpose' => "

Tokenizes and parses QuickBasic code.
This is under development.<p>
Latest snapshots of the lexer and parser are available:
<br><a href=\"/WWW/diary/bd-2002-04-08-qb.l.txt\">qb.l // 2002-04-08 (3 kB)</a>
<br><a href=\"/WWW/diary/bd-2002-04-08-qb.y.txt\">qb.y // 2002-04-08 (8 kB)</a>
<p>
If you are interested in joining the development,
please <a href=\"mailto:bisqwit@iki.fi\">contact me</a>.

", '1. Goals' => "

To provide tools for running QuickBASIC programs in
Linux and other non-MS-DOS -environments.

", '1.1. Features not omitted' => "

These features are often missing from other BASIC implementations,
because they are difficult to implement or not seemed as important.

<ul>
 <li><code>ON n GOTO</code>/<code>GOSUB</code></li>
 <li><code>READ/<code>DATA/<code>RESTORE</code></li>
 <li>Fully compatible <code>INKEY\$</code></li>
 <li><code>TIMER</code> function</li>
 <li>Type compatibility (<code>INTEGER</code> must still be 16-bit signed integer etc)</li>
 <li><code>PLAY/<code>ON PLAY</code></li>
 <li><code>DEF FN</code></li>
 <li>Number printing and stringifying (<code>PRINT</code>, <code>STR\$</code>) compatibility</li>
 <li><code>OPEN</code>: Both syntaxes</li>
 <li><code>NEXT</code> with comma separated list of variables</li>
 <li><code>IF</code>: Both syntaxes plus implicit <code>GOTO</code> in <code>THEN</code> and <code>ELSE</code> support.</li>
 <li><code>PRINT</code> abbreviated as <code>?</code> support</li>
</ul>

", '1.1. Features supported if possible' => "

Some of these features require emulation of
PC-style hardware without direct hardware access.

<ul>
 <li><code>DEF SEG &amp;HB800</code>/<code>PEEK</code>/<code>POKE</code> support for direct video access in text mode</li>
 <li><code>IN</code>/<code>OUT</code> support to ports &amp;H388 - &amp;H389 for AdLib support</li>
 <li><code>SCREEN</code> 12/13, <code>PSET</code> and other drawing stuff</li>
</ul>

", '1.1. Features not considered to be supported' => "

These QuickBASIC features are not seen as important, and
will not be supported (unless somebody has too much time).

<ul>
 <li>All the excessive <code>ERR</code> codes like \"Syntax error\" etc</li>
 <li><code>KEY ON</code>/<code>KEY OFF</code>  (dunno about <code>ON KEY</code>)</li>
 <li><code>FIELD</code> and other obscure file features (some of which were new in QB 7.0)</li>
</ul>

", '1.1. Extra features' => "

There are no plans for extra features yet, but internationalizations
like UTF-8 support would be nice.

", '1. Copying' => "

qbc has been written by Joel Yliluoma, a.k.a.
<a href=\"http://bisqwit.iki.fi/\">Bisqwit</a>,<br>
and is distributed under the terms of the
<a href=\"http://www.gnu.org/licenses/licenses.html#GPL\">General Public License</a> (GPL).

", '1. Requirements' => "

At least these GNU tools are required: flex, bison, gcc, make.<br>

");
include '/WWW/progdesc.php';
